CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions
Socket Class Reference

`#include <PracticalSocket.h>`

Inheritance diagram for Socket:

List of all members.

## Public Member Functions
| ~Socket ()
string | getLocalAddress () throw (SocketException)
unsigned short | getLocalPort () throw (SocketException)
void | setLocalPort (unsigned short localPort) throw (SocketException)
void | setLocalAddressAndPort (const string &localAddress, unsigned short localPort=0) throw (SocketException)

## Static Public Member Functions
static void | cleanUp () throw (SocketException)
static unsigned short | resolveService (const string &service, const string &protocol="tcp")

## Protected Member Functions
| Socket (int type, int protocol) throw (SocketException)
| Socket (int sockDesc)

## Protected Attributes
int | sockDesc

## Private Member Functions
| Socket (const Socket &sock)
void | operator= (const Socket &sock)

## Detailed Description

Socket super class

Definition at line 56 of file PracticalSocket.h.

## Constructor & Destructor Documentation

Socket::~Socket | ( |  | ) |

Close and deallocate this socket

Definition at line 106 of file PracticalSocket.cpp.

References closesocket.

Socket::Socket | ( | const Socket & | sock | ) |
| private

Socket::Socket | ( | int | type,
|  | int | protocol
| ) |  | throw (SocketException)
| protected

Definition at line 82 of file PracticalSocket.cpp.

Socket::Socket | ( | int | sockDesc | ) |
| protected

Definition at line 102 of file PracticalSocket.cpp.

## Member Function Documentation

string Socket::getLocalAddress | ( |  | ) | throw (SocketException)

Get the local address

Returns:
  local address of socket

Exceptions:

  SocketException | thrown if fetch fails

Definition at line 115 of file PracticalSocket.cpp.

unsigned short Socket::getLocalPort | ( |  | ) | throw (SocketException)

Get the local port

Returns:
  local port of socket

Exceptions:

  SocketException | thrown if fetch fails

Definition at line 125 of file PracticalSocket.cpp.

void Socket::setLocalPort | ( | unsigned short | localPort | ) | throw (SocketException)

Set the local port to the specified port and the local address to any interface

Parameters:

  localPort | local port

Exceptions:

  SocketException | thrown if setting local port fails

Definition at line 135 of file PracticalSocket.cpp.

void Socket::setLocalAddressAndPort | ( | const string & | localAddress,
|  | unsigned short | localPort = `0`
| ) |  | throw (SocketException)

Set the local port to the specified port and the local address to the specified address. If you omit the port, a random port will be selected.

Parameters:

  localAddress | local address
  localPort | local port

Exceptions:

  SocketException | thrown if setting local port or address fails

Definition at line 148 of file PracticalSocket.cpp.

References fillAddr().

void Socket::cleanUp | ( |  | ) | throw (SocketException)
| static

If WinSock, unload the WinSock DLLs; otherwise do nothing. We ignore this in our sample client code but include it in the library for completeness. If you are running on Windows and you are concerned about DLL resource consumption, call this after you are done with all Socket instances. If you execute this on Windows while some instance of Socket exists, you are toast. For portability of client code, this is an empty function on non-Windows platforms so you can always include it.

Parameters:

  buffer | buffer to receive the data
  bufferLen | maximum number of bytes to read into buffer

Returns:
  number of bytes read, 0 for EOF, and -1 for error

Exceptions:

  SocketException | thrown WinSock clean up fails

Definition at line 159 of file PracticalSocket.cpp.

unsigned short Socket::resolveService | ( | const string & | service,
|  | const string & | protocol = `"tcp"`
| ) |  |
| static

Resolve the specified service for the specified protocol to the corresponding port number in host byte order

Parameters:

  service | service to resolve (e.g., "http")
  protocol | protocol of service to resolve. Default is "tcp".

Definition at line 167 of file PracticalSocket.cpp.

void Socket::operator= | ( | const Socket & | sock | ) |
| private

## Member Data Documentation

int Socket::sockDesc
| protected

Definition at line 126 of file PracticalSocket.h.

Referenced by TCPServerSocket::accept(), UDPSocket::disconnect(), CommunicatingSocket::getForeignAddress(), CommunicatingSocket::getForeignPort(), UDPSocket::joinGroup(), UDPSocket::leaveGroup(), UDPSocket::recvFrom(), UDPSocket::sendTo(), UDPSocket::setBroadcast(), and UDPSocket::setMulticastTTL().

The documentation for this class was generated from the following files:

- CSL/Spatializers/VBAP/PracticalSocket.h
- CSL/Spatializers/VBAP/PracticalSocket.cpp